
/*
Created by, Larissa Tsai 2018
Iron Man 
controls a lil iron man robot; arc reactor color changes according to temp; if there's sufficient light, then the robot waves at you
*/ 


#include <Servo.h>                                       
#include <Adafruit_NeoPixel.h>

const int LIGHT = 5;
const int TEMP = 6;
const int SERVO = 9;
const int RING = 10;
const int NUM_LIGHTS = 7;

Adafruit_NeoPixel arc = Adafruit_NeoPixel(NUM_LIGHTS, RING);
Servo arm;
int armPos = 5;
int dir = 5;

void setup(){
    arm.attach(SERVO);
    arc.begin();
    arc.clear();
    arc.show();

    dispTemp(50);

    Serial.begin(9600);
}

void loop(){

    // light is 0-900
    if(analogRead(LIGHT) >= 200){ 
        arm.write(armPos);

        armPos += dir;      
        if(armPos >= 95 || armPos <= 5){
            dir *= -1;
        }
    }

    // arc reactor
    dispTemp(5);
    
}

// displays the temperature as lights, pausing del milliseconds between each lighting  
// range is light blue to red (through dark blue n purple n pink)
// range: (0, 232, 232) --> (232, 0, 0)
// decrease middle, increase first, decrease last

void dispTemp(int del){
    int techTemp = analogRead(TEMP);
    Serial.println(techTemp);
    float currTemp = map(techTemp, 0, 500, 0, 29);   // temp of this room is ~12 (out of 30)
    
    
    uint32_t current; // the color according to temp
    int mapped = map(((int)currTemp)%10, 0, 9, 0, 232);

    switch((int)(currTemp/10)){
        case 0:
            current = arc.Color(0, 232 - mapped, 232);
            break;
        case 1:
            current = arc.Color(mapped, 0, 232);
            break;
        default:
            current = arc.Color(232, 0, 232 - mapped);
            break;  
    }

    for(int i = 0; i < NUM_LIGHTS; i++){
        arc.setPixelColor(i, current);
        arc.show();
        delay(del);
    }
}
